> This page is for API, version 2026-01-01 (Stable) (default).
> For other versions, use one of these documentation indexes:
> - 2026-01-01 (Stable) (default): https://developer.deel.com/api/stable/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developer.deel.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developer.deel.com/_mcp/server.

# List of shifts

GET https://api.letsdeel.com/rest/v2/time_tracking/shifts

Retrieve a paginated list of shifts with details such as start and end times, breaks, metadata, and summary metrics. Supports pagination through `limit` and `offset` query parameters and filtering by `contractId`, date range (`fromDate` and `toDate`).

 **Token scopes**: `time-tracking:read`

Reference: https://developer.deel.com/api/endpoints/time-tracking-shifts/get-time-tracking-shifts

## Authentication

- `Authorization` header (bearer token, required) — ## Authentication The Deel API uses bearer tokens to authenticate requests. All API calls must be made over HTTPS — calls over plain HTTP or without authentication will fail. ```curl curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \ -H 'Authorization: Bearer YOUR-TOKEN-HERE' ``` [Learn more about authentication](/api/authentication)
- `Authorization` header (bearer token, required) — Standard OAuth2 security scheme based on https://swagger.io/docs/specification/authentication/

## Servers

- `https://api.letsdeel.com/rest` (Production, default)
- `https://api-staging.letsdeel.com/rest` (Demo)

## Request

### Query parameters

- `limit` (integer, optional) — Limit the number of results
- `offset` (integer, optional) — Offset for pagination
- `from_date` (string, optional) — Filter shifts from this date (YYYY-MM-DD)
- `to_date` (string, optional) — Filter shifts until this date (YYYY-MM-DD)
- `contract_id` (list of string, optional) — Filter shifts by one or more contract IDs
- `contract_id[]` (list of string, optional) — Filter shifts by one or more contract IDs.

## Response

### 200

Successful response with paginated shifts.

- `data` (list of V2TimeTrackingShiftsGetResponsesContentApplicationJsonSchemaDataItems, required)
- `page` (V2TimeTrackingShiftsGetResponsesContentApplicationJsonSchemaPage, required)

## Errors

### 401 Unauthorized Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 403 Forbidden Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 404 Not Found Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 500 Internal Server Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

## Types

### V2TimeTrackingShiftsGetResponsesContentApplicationJsonSchemaDataItems

- `created_at` (string, required) — Date when the shift was created
- `shift_type` (enum, required) — Type of the shift
  - Allowed values: `REGULAR`, `CORRECTION_ABSOLUTE`, `CORRECTION_DELTA`, `TIME_OFF_QUALIFYING`
- `updated_at` (string, required) — Date when the shift was last updated
- `contract_id` (string, required) — Associated contract ID for the shift
- `description` (string, required) — Description of the shift
- `external_id` (string, required) — ID specified by the client for uniquely identifying the shift
- `date_of_work` (string, required) — Date when the shift takes place, in YYYY-MM-DD format
- `meta` (V2TimeTrackingShiftsGetResponsesContentApplicationJsonSchemaDataItemsMeta, optional)
- `summary` (V2TimeTrackingShiftsGetResponsesContentApplicationJsonSchemaDataItemsSummary, optional)
- `payroll_cycle_ref` (V2TimeTrackingShiftsGetResponsesContentApplicationJsonSchemaDataItemsPayrollCycleRef, optional) — Payroll cycle reference
- `shift_reference_id` (string, optional) — External ID of the original shift this one references (set on correction shifts).

### V2TimeTrackingShiftsGetResponsesContentApplicationJsonSchemaPage

- `offset` (double, required) — Offset for pagination
- `total_rows` (double, required) — Total number of shifts
- `items_per_page` (double, required) — Number of shifts per page

### ApiErrorRequest

- `method` (string, optional) — The HTTP method of the failed request
- `url` (string, optional) — The relative URL of the failed request
- `status` (double, optional) — The status code of the response
- `api_req_id` (string, optional) — The request ID of the failed request
- `docs` (string, optional) — A link to the official documentation for the requested endpoint resource
- `source` (string, optional) — The source handler which produced the returned error
- `code` (double, optional) — The code of the source handler which produced the returned error

### ApiError

- `message` (string, optional) — A description of the returned error
- `path` (string, optional) — The JSON path where input validation failed

### V2TimeTrackingShiftsGetResponsesContentApplicationJsonSchemaDataItemsMeta

- `end` (V2TimeTrackingShiftsGetResponsesContentApplicationJsonSchemaDataItemsMetaEnd, required)
- `start` (V2TimeTrackingShiftsGetResponsesContentApplicationJsonSchemaDataItemsMetaStart, required)
- `breaks` (list of V2TimeTrackingShiftsGetResponsesContentApplicationJsonSchemaDataItemsMetaBreaksItems, optional)
- `approval_date` (string, optional) — Approval date for the shift, in ISO format

### V2TimeTrackingShiftsGetResponsesContentApplicationJsonSchemaDataItemsSummary

- `shift_rate_external_id` (string, required) — External ID of the shift rate associated with this shift
- `time_unit` (enum, optional) — The unit of time for the shift (DAY, HOUR, MONTH, WEEK)
  - Allowed values: `DAY`, `HOUR`, `MONTH`, `WEEK`
- `time_amount` (double, optional) — The amount of time for the shift
- `total_break_hours` (double, optional) — Total break duration in hours
- `payable_break_hours` (double, optional) — Break hours that are payable
- `total_payable_hours` (double, optional) — Total payable working hours after break deductions
- `shift_duration_hours` (double, optional) — Total duration of the shift in hours

### V2TimeTrackingShiftsGetResponsesContentApplicationJsonSchemaDataItemsPayrollCycleRef

Payroll cycle reference

- `date` (string, required) — date in ISO

### V2TimeTrackingShiftsGetResponsesContentApplicationJsonSchemaDataItemsMetaEnd

- `date` (string, required) — Shift end date
- `time` (string, required) — Shift end time in HH:mm format
- `is_rest_day` (boolean, required) — Indicates if it is a rest day
- `is_public_holiday` (boolean, required) — Indicates if it is a public holiday

### V2TimeTrackingShiftsGetResponsesContentApplicationJsonSchemaDataItemsMetaStart

- `date` (string, required) — Shift start date
- `time` (string, required) — Shift start time in HH:mm format
- `is_rest_day` (boolean, required) — Indicates if it is a rest day
- `is_public_holiday` (boolean, required) — Indicates if it is a public holiday

### V2TimeTrackingShiftsGetResponsesContentApplicationJsonSchemaDataItemsMetaBreaksItems

- `end` (V2TimeTrackingShiftsGetResponsesContentApplicationJsonSchemaDataItemsMetaBreaksItemsEnd, required)
- `start` (V2TimeTrackingShiftsGetResponsesContentApplicationJsonSchemaDataItemsMetaBreaksItemsStart, required)
- `is_paid` (boolean, optional) — Indicates if the break is paid

### V2TimeTrackingShiftsGetResponsesContentApplicationJsonSchemaDataItemsMetaBreaksItemsEnd

- `date` (string, required) — Break end date
- `time` (string, required) — Break end time in HH:mm format

### V2TimeTrackingShiftsGetResponsesContentApplicationJsonSchemaDataItemsMetaBreaksItemsStart

- `date` (string, required) — Break start date
- `time` (string, required) — Break start time in HH:mm format

## Examples

**Response**

```json
{
  "data": [
    {
      "created_at": "2024-02-01T00:00:00.000Z",
      "shift_type": "REGULAR",
      "updated_at": "2024-02-10T00:00:00.000Z",
      "contract_id": "contract-id-456",
      "description": "Night shift at warehouse",
      "external_id": "external-id-123",
      "date_of_work": "2024-02-12",
      "meta": {
        "end": {
          "date": "2024-02-12",
          "time": "16:00",
          "is_rest_day": false,
          "is_public_holiday": false
        },
        "start": {
          "date": "2024-02-12",
          "time": "08:00",
          "is_rest_day": false,
          "is_public_holiday": false
        }
      },
      "summary": {
        "shift_rate_external_id": "shift-rate-id-789",
        "time_unit": "HOUR",
        "time_amount": 8,
        "total_break_hours": 0.5,
        "payable_break_hours": 0.5,
        "total_payable_hours": 7.5,
        "shift_duration_hours": 8
      },
      "payroll_cycle_ref": {
        "date": "2024-02-11T12:00:00.000Z"
      }
    }
  ],
  "page": {
    "offset": 0,
    "total_rows": 1,
    "items_per_page": 20
  }
}
```

**SDK Code**

```python
import requests

url = "https://api.letsdeel.com/rest/v2/time_tracking/shifts"

querystring = {"contract_id":"[\"CONTRACT-001\",\"CONTRACT-002\"]","contract_id[]":"[\"CONTRACT-001\",\"CONTRACT-002\"]","from_date":"2023-01-01","limit":"20","offset":"0","to_date":"2023-12-31"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/time_tracking/shifts?contract_id=%5B%22CONTRACT-001%22%2C%22CONTRACT-002%22%5D&contract_id%5B%5D=%5B%22CONTRACT-001%22%2C%22CONTRACT-002%22%5D&from_date=2023-01-01&limit=20&offset=0&to_date=2023-12-31';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/time_tracking/shifts?contract_id=%5B%22CONTRACT-001%22%2C%22CONTRACT-002%22%5D&contract_id%5B%5D=%5B%22CONTRACT-001%22%2C%22CONTRACT-002%22%5D&from_date=2023-01-01&limit=20&offset=0&to_date=2023-12-31"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/time_tracking/shifts?contract_id=%5B%22CONTRACT-001%22%2C%22CONTRACT-002%22%5D&contract_id%5B%5D=%5B%22CONTRACT-001%22%2C%22CONTRACT-002%22%5D&from_date=2023-01-01&limit=20&offset=0&to_date=2023-12-31")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.letsdeel.com/rest/v2/time_tracking/shifts?contract_id=%5B%22CONTRACT-001%22%2C%22CONTRACT-002%22%5D&contract_id%5B%5D=%5B%22CONTRACT-001%22%2C%22CONTRACT-002%22%5D&from_date=2023-01-01&limit=20&offset=0&to_date=2023-12-31")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.letsdeel.com/rest/v2/time_tracking/shifts?contract_id=%5B%22CONTRACT-001%22%2C%22CONTRACT-002%22%5D&contract_id%5B%5D=%5B%22CONTRACT-001%22%2C%22CONTRACT-002%22%5D&from_date=2023-01-01&limit=20&offset=0&to_date=2023-12-31', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/time_tracking/shifts?contract_id=%5B%22CONTRACT-001%22%2C%22CONTRACT-002%22%5D&contract_id%5B%5D=%5B%22CONTRACT-001%22%2C%22CONTRACT-002%22%5D&from_date=2023-01-01&limit=20&offset=0&to_date=2023-12-31");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/time_tracking/shifts?contract_id=%5B%22CONTRACT-001%22%2C%22CONTRACT-002%22%5D&contract_id%5B%5D=%5B%22CONTRACT-001%22%2C%22CONTRACT-002%22%5D&from_date=2023-01-01&limit=20&offset=0&to_date=2023-12-31")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```